unit UFEspeciales;

interface
uses
  SysUtils, Variants, Classes, math, UApoyo;

  procedure FE_Ecualiza ( Ma : Mat3d; var Mb : Mat3d );

implementation

  procedure FE_Ecualiza ( Ma : Mat3d; var Mb : Mat3d );
  var
    x,y,can     : integer;
    HH          : array [0..2,0..255] of integer;
    AA          : array [0..2,0..255] of single;
    tono        : integer;

  // histograma
  procedure FEHisto();
  var
    xx,yy,kk,kan : integer;
  begin
    // limpiar histogramas
    for kan := 0 to 2 do if Kanales[kan] then
      for kk := 0 to _lamb do HH[kan][kk] := 0;

    // contar por tono : hacer el histograma
    for kan := 0 to 2 do if Kanales[kan]
      then // contar
        for yy := _y1 to _y2 - 1 do
          for xx := _x1 to _x2 - 1 do begin
          // ---
            kk := aj256(Ma.dat[xx][yy][kan]);
            inc(HH[kan][kk]);
          // ---
          end;
  end;

  // Acumulativa
  procedure FEAcumu();
  var
    kk,kan : integer;
    vol    : integer;
    ff     : single;
  begin
    // sumamos
    for kan := 0 to 2 do if Kanales[kan] then begin
      AA[kan][0] := HH[kan][0];
      for kk := 1 to _lamb do
        AA[kan][kk] := AA[kan][kk-1] + HH[kan][kk];
    end;

    // volumen de pixeles
    vol := (_x2-_x1+1)*(_y2-_y1+1);

    // normaliza
    ff := _lamb/vol;
    for kan := 0 to 2 do if Kanales[kan] then
      for kk := 1 to _lamb do
        AA[kan][kk] := ff*AA[kan][kk];

  end;


  begin // metodo principal

    FEHisto();
    FEAcumu();

    for can := 0 to 2 do if Kanales[can]
      then // aplica el filtro
        for y := _y1 to _y2 - 1 do
          for x := _x1 to _x2 - 1 do begin
          // ---
            tono := aj256(Ma.dat[x][y][can]);
            Mb.dat[x][y][can] := AA[can][tono];
          // ---
          end;
  end;


end.

